//ICC-AVR application builder : 11.03.2002 20:01:52
// Target : 2313
// Crystal: 3.6864Mhz

#include <io2313v.h>
#include <macros.h>

# define max_count 900

//////////////////////////
///  

int result; //   -  
char low_result; //   
char hi_result;  //   
int temp;  //   
char no_INT0=1;  // INT0   



//////////////////////////
///   

void port_init(void);
void timer0_init(void);
void timer0_ovf_isr(void);
void uart0_init(void);
void int0_isr(void);
void init_devices(void);


void get_period(void);
void send_result(void);
void save_result(void);


//////////////////////////

void main(void)
{
 init_devices();
 
 while(1);
 
}


//////////////////////////



void get_period(void)
{
//    INT0
//  "1"  _6 . GIFR
GIFR |= 0x40;// turn on bit6 
// . Help  "Bit Twiddling"

//     INT0
GIMSK = 0x40;

while(no_INT0); //   
//   

//   -   
no_INT0 = 1;
//    INT0

GIFR |= 0x40;//   INT0

//    
//    

while((no_INT0)&&(result<max_count))
{
 result++;
}
//     .
//      
//     
//  max_count

// .  INT0
GIMSK = 0x00; //  =0;

no_INT0 = 1;
//    INT0
}













//////////////////////////



void send_result(void)
{
temp = result; //  

low_result=(temp & 0x00FF); 
//   8   
//    

temp = result;
hi_result= temp >> 8; //   8  
//    

hi_result = + 65; //  0,1,2,3   
                  //   A B C D

putchar(0x0D); //   
// ..     -  

putchar(hi_result); 
//   

putchar(' ');
//   

putchar(low_result);
//   


}




//////////////////////////














void save_result(void)
{

}



void port_init(void)
{
 PORTB = 0xFF;
 DDRB  = 0x07; 
 PORTD = 0x7F;
 DDRD  = 0x00; 
}

//TIMER0 initialisation - prescale:1024
// desired value: 50Hz
// actual value: 50,000Hz (0,0%)
void timer0_init(void)
{
 TCCR0 = 0x00; //stop timer
 TCNT0 = 0xB8; //set count
 TCCR0 = 0x05; //start timer
}


/////////////////////////////////////////////////

#pragma interrupt_handler timer0_ovf_isr:7
void timer0_ovf_isr(void)
{
 //TIMER0   255  0
 TCNT0 = 0xB8; 
 //     184
 
 //..   20   
 
get_period();
//.. 

send_result();
//..   rs232 

save_result();
//..    

result=0;
//  
}

/////////////////////////////////////////////////


//UART0 initialisation
// desired baud rate: 9600
// actual: baud rate:9600 (0,0%)
void uart0_init(void)
{
 UCR  = 0x00; //disable while setting baud rate
 UBRR = 0x17; //set baud rate
 UCR  = 0x08; //enable
}

#pragma interrupt_handler int0_isr:2
void int0_isr(void)
{
 //external interupt on INT0
 no_INT0 = 0;
 //  no_INT0
}

//call this routine to initialise all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 timer0_init();
 uart0_init();

 MCUCR = 0x02;
 
 GIMSK = 0x00; // INT0 
               // 0x40 - 
 TIMSK = 0x02;
 
 SEI(); //re-enable interrupts
 //all peripherals are now initialised
}