//ICC-AVR application builder : 06.03.2002 13:12:21
// Target : 2313
// Crystal: 3.6864Mhz

#include <io2313v.h>
#include <macros.h>

unsigned char ctr=0;

void port_init(void)
{
 PORTB = 0xFF;
 DDRB  = 0x00; 
 PORTD = 0x7F;
 DDRD  = 0x00; 
}

//TIMER0 initialisation - prescale:1024
// desired value: 50Hz
// actual value: 50,000Hz (0,0%)
void timer0_init(void)
{
 TCCR0 = 0x00; //stop timer
 TCNT0 = 0xB8; //set count
 TCCR0 = 0x05; //start timer
}

#pragma interrupt_handler timer0_ovf_isr:7
void timer0_ovf_isr(void)
{
 //TIMER0 has overflowed
 TCNT0 = 0xB8; //reload counter value
 
 DDRB = 0x20; // 0010 0000

 PORTB = 0x20; // 0010 0000  

  //

  while(ctr<200)
  {
   	ctr++; // 
  }

PORTB = 0; //

ctr=0; 

putchar('R');
putchar('x');
 
}

//UART0 initialisation
// desired baud rate: 9600
// actual: baud rate:9600 (0,0%)
void uart0_init(void)
{
 UCR  = 0x00; //disable while setting baud rate
 UBRR = 0x17; //set baud rate
 UCR  = 0x08; //enable
}

//call this routine to initialise all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 timer0_init();
 uart0_init();

 MCUCR = 0x00;
 GIMSK = 0x00;
 TIMSK = 0x02;
 SEI(); //re-enable interrupts
 //all peripherals are now initialised
}


void main (void)
{
init_devices();

while(1);
}

